local AceOO = AceLibrary("AceOO-2.0")

CircleSplut = AceOO.Class(Splutton)

local self = CircleSplut

CircleSplut.prototype.Radius = 100

function CircleSplut.prototype:init(Parent, Data)
	CircleSplut.super.prototype.init(self, Parent, Data)
	self:Splut()
end

function CircleSplut.prototype:CreateButton()
	if not self.Button then
		CircleSplut.super.prototype.CreateButton(self)

		self.Button:SetNormalTexture("Interface\\AddOns\\Splut\\Textures\\serenity0")
		self.Button:SetPushedTexture("Interface\\AddOns\\Splut\\Textures\\serenity0")
		self.Button:SetHighlightTexture("Interface\\AddOns\\Splut\\Textures\\serenity1")
		
		if self.Type == "main" then
			self.Button:SetScript("OnEnter", nil)

			local backframe = CreateFrame("Button", self.Button:GetName().."frame", self.Parent and self.Parent.Button or UIParent)
			backframe:SetPoint("CENTER", self.Button)
			backframe:SetWidth(2*self.Radius)
			backframe:SetHeight(2*self.Radius)
			backframe:RegisterForClicks("LeftButtonUp", "RightButtonUp")
			backframe:SetFrameLevel(self.Button:GetFrameLevel()-1)
			self.HitFrame = backframe
			self.HitFrame:Hide()
		end
	end
end

local math_pi = math.pi
local math_acos = math.acos
local math_cos = math.cos
local math_sin = math.sin
local math_atan = math.atan2
local math_abs = math.abs

function CircleSplut.prototype:SplutSector()
	local x, y = GetCursorPosition()
	local cx, cy = self.HitFrame:GetCenter()
	local scale = UIParent:GetEffectiveScale()
	cx, cy = scale*cx, scale*cy
	local rad = math_atan((y-cy),(x-cx))
	if rad < 0 then rad = rad + 2*math_pi end
	rad = rad + (self.Rad or 0) + (self.Segment/2) -- we're now in the right sector

	if rad > 2*math_pi then
		rad = math.rad(1)
	end

	local sector = math.ceil(rad / self.Segment)

	if self.Parent then
		if sector > 1 then 
			self.Children[sector - 1].Button:Click()
		else
			self.Parent.Button:Click()
		end
	else
		self.Children[sector]:Click()
	end

end


function CircleSplut.prototype:Splut()
	if self.Type ~= "main" then return end
	

	local kids = self.Children and #self.Children or 0
	
	if self.Parent then kids = kids + 1 end
	if kids > 1 then
		self.Segment = 2*math_pi/kids -- Store the segment radians
		local segment = self.Segment
		for i=1,#self.Children do
			local rad
			local add = self.Rad or 0 
			rad = (i * segment) - add - (not self.Parent and segment or 0)
			local X = self.Radius * math_cos(rad)
			local Y = self.Radius * math_sin(rad)
			self.Children[i].Rad = math_pi - rad
			self.Children[i].Button:SetAttribute("ofsx",X)
			self.Children[i].Button:SetAttribute("ofsy",Y)
			self.Children[i].Button:Hide()
		end
	end
end
